#include "AdDemoView.h"
#include <string>


bool rewardedAdShowRequested = false;
static AdDemoView* viewInstance1 = NULL;
static AdDemoView* viewInstance2 = NULL;

bool AdDemoView::init()
{
    if (!BaseView::init())
        return false;
    
    _coinsEarned = 0;
    
    logo->setPosition(CCPoint(logo->getPosition().x, logo->getPosition().y + 100));
    
    int yPos = logo->getPosition().y - logo->getContentSize().height / 2;
    
    yPos -= 100;
    
    _txtPointsEarned = BaseView::createLabel("Points Earned: 0", 35, ccBLACK, CCPoint(visibleSize.width / 2, yPos));
    this->addChild(_txtPointsEarned);
    
    yPos -= 100;
    
    _txtStatus = createLabel("<perform an action>", 25, ccWHITE, CCPoint(visibleSize.width / 2, yPos));
    this->addChild(_txtStatus);
    
    yPos -= 120;
    
    _btnCacheVideoAd = createButton("Cache Video Ad", menu_selector(AdDemoView::handleCacheVideoAd), this, "btn_purple_normal.png", "btn_purple_down.png");
    _btnCacheVideoAd->setPosition(CCPoint(visibleSize.width / 2, yPos));
    menuContainer->addChild(_btnCacheVideoAd);
    
    yPos -= 100;
    
    _btnCacheInterstitialAd = createButton("Cache Interstial Ad", menu_selector(AdDemoView::handleCacheInterstitialAd), this);
    _btnCacheInterstitialAd->setPosition(CCPoint(visibleSize.width / 2, yPos));
    menuContainer->addChild(_btnCacheInterstitialAd);
    
    yPos -= 100;
    
    
    _btnShowVideoAd = createButton("Show Video Ad", menu_selector(AdDemoView::handleShowVideoAd), this, "btn_purple_normal.png", "btn_purple_down.png");
    _btnShowVideoAd->setPosition(CCPoint(visibleSize.width / 2, yPos));
    menuContainer->addChild(_btnShowVideoAd);
    
    yPos -= 100;
    
    _btnShowInterstitialAd = createButton("Show Interstitial Ad", menu_selector(AdDemoView::handleShowInterstitialAd), this);
    _btnShowInterstitialAd->setPosition(CCPoint(visibleSize.width / 2, yPos));
    menuContainer->addChild(_btnShowInterstitialAd);
    
    yPos -= 100;
    
    _btnExportLog = createButton("Export Log", menu_selector(AdDemoView::handleExportLog), this);
    _btnExportLog->setPosition(CCPoint(visibleSize.width / 2, yPos));
    _btnExportLog->setScale(0.7f);
    menuContainer->addChild(_btnExportLog);
    
    // listen for pokkt events
    PCPokktManager::setAdEventListener(AD_AVAILABILITY_EVENT, PC_AD_EVENT_SELECTOR(AdDemoView::handleAdAvailability), this);
    PCPokktManager::setAdEventListener(AD_CACHING_COMPLETED_EVENT, PC_AD_EVENT_SELECTOR(AdDemoView::handleAdCachingCompleted), this);
    PCPokktManager::setAdEventListener(AD_CACHING_FAILED_EVENT, PC_AD_EVENT_SELECTOR(AdDemoView::handleAdCachingFailed), this);
    PCPokktManager::setAdEventListener(AD_DISPLAYED_EVENT, PC_AD_EVENT_SELECTOR(AdDemoView::handleAdDisplayed), this);
    PCPokktManager::setAdEventListener(AD_SKIPPED_EVENT, PC_AD_EVENT_SELECTOR(AdDemoView::handleAdSkipped), this);
    PCPokktManager::setAdEventListener(AD_COMPLETED_EVENT, PC_AD_EVENT_SELECTOR(AdDemoView::handleAdCompleted), this);
    PCPokktManager::setAdEventListener(AD_CLOSED_EVENT, PC_AD_EVENT_SELECTOR(AdDemoView::handleAdClosed), this);
    PCPokktManager::setAdEventListener(AD_GRATIFIED_EVENT, PC_AD_EVENT_SELECTOR(AdDemoView::handleAdGratified), this);
    
    return true;
}

AdDemoView::~AdDemoView()
{
    PCPokktManager::removeAdEventListener(AD_AVAILABILITY_EVENT);
    PCPokktManager::removeAdEventListener(AD_CACHING_COMPLETED_EVENT);
    PCPokktManager::removeAdEventListener(AD_CACHING_FAILED_EVENT);
    PCPokktManager::removeAdEventListener(AD_DISPLAYED_EVENT);
    PCPokktManager::removeAdEventListener(AD_SKIPPED_EVENT);
    PCPokktManager::removeAdEventListener(AD_COMPLETED_EVENT);
    PCPokktManager::removeAdEventListener(AD_CLOSED_EVENT);
    PCPokktManager::removeAdEventListener(AD_GRATIFIED_EVENT);
}

void AdDemoView::handleBackPress(CCObject* obj)
{
    ChangeViewParams* params = new ChangeViewParams();
    params->viewToChange = DemoSelectorView;
    params->adConfig = NULL;
    changeView(params);
}

void AdDemoView::setAdConfig(PCAdConfig* adConfig)
{
    _adConfig = adConfig;
}

AdDemoView* AdDemoView::getView(bool isRewarded)
{
    if (isRewarded)
    {
        if (viewInstance1 == NULL)
        {
            viewInstance1 = AdDemoView::create();
            viewInstance1->retain();
        }
        return viewInstance1;
    }
    else
    {
        if (viewInstance2 == NULL)
        {
            viewInstance2 = AdDemoView::create();
            viewInstance2->retain();
        }
        return viewInstance2;
    }
    
    return NULL;
}

void AdDemoView::handleCacheVideoAd(CCObject *pSender)
{
    _btnCacheVideoAd->setEnabled(false);
    _btnShowVideoAd->setEnabled(false);
    changeButtonLabel(_btnCacheVideoAd, "Video ad is downloading...");
    changeButtonLabel(_btnShowVideoAd, "Video ad is downloading...");
    
    // request pokkt-sdk for a Video ad to be cached
    _adConfig->adFormat = VIDEO;
    PCPokktManager::cacheAd(_adConfig);
}

void AdDemoView::handleShowVideoAd(CCObject *pSender)
{
    CCLOG("checking for any available video-ad...");
    _adConfig->adFormat = VIDEO;
    PCPokktManager::checkAdAvailability(_adConfig);
}

void AdDemoView::handleCacheInterstitialAd(CCObject *pSender)
{
    _btnCacheInterstitialAd->setEnabled(false);
    _btnShowInterstitialAd->setEnabled(false);
    changeButtonLabel(_btnCacheInterstitialAd, "Interstitial ad is downloading...");
    changeButtonLabel(_btnShowInterstitialAd, "Interstitial ad is downloading...");
    
    // request pokkt-sdk for a interstitial to be cached
    
    _adConfig->adFormat = INTERSTITIAL;
    PCPokktManager::cacheAd(_adConfig);
}

void AdDemoView::handleShowInterstitialAd(CCObject *pSender)
{
    // request pokkt-sdk to show a interstitial ad
    
    CCLOG("checking for any available interstitial-ad...");

    _adConfig->adFormat = INTERSTITIAL;
    PCPokktManager::checkAdAvailability(_adConfig);
}

void AdDemoView::handleExportLog(CCObject* pSender)
{
    PCPokktManager::exportLog();
}

// pokkt handlers
void AdDemoView::handleAdAvailability(PCAdConfig* adConfig, std::map<std::string, std::string> extraValues)
{
    if (adConfig->screenName != _adConfig->screenName)
        return;
    
    // extract values
    bool isAvailable = extraValues[IS_AVAILABLE].compare("true") == 0;
    
    CCLOG("[POKKT-CPP] %s %s ad for %s is %s!", (adConfig->isRewarded ? "rewarded" : "non-rewarded"),
                                                (adConfig->adFormat == VIDEO ? "video" : "interstitial"),
                                                adConfig->screenName.c_str(),
                                                (isAvailable ? "available!" : "not available!"));
    
    changeLabelText(_txtStatus, isAvailable ? "ad available!" : "no ads available");
    
    PCPokktManager::showAd(adConfig);
}

void AdDemoView::handleAdCachingCompleted(PCAdConfig* adConfig, std::map<std::string, std::string> extraValues)
{
    if (adConfig->screenName != _adConfig->screenName)
        return;
    
    // extract values
    float vc = 0.0f;
    std::stringstream(extraValues[AD_VC]) >> vc;
    
    CCLOG("%s %s ad is cached for %s, associated vc is %f", (adConfig->isRewarded ? "rewarded" : "non-rewarded"),
                                                            (adConfig->adFormat == VIDEO ? "video" : "interstitial"),
                                                            adConfig->screenName.c_str(),
                                                            vc);
    
    changeLabelText(_txtStatus, "ad cached!");
    
    if (adConfig->adFormat == VIDEO)
    {
        changeButtonLabel(_btnCacheVideoAd, "Video ad is cached!");
        changeButtonLabel(_btnShowVideoAd, "Show Video Ad (Cached)");
        
        _btnShowVideoAd->setEnabled(true);
    }
    else if(adConfig->adFormat == INTERSTITIAL)
    {
        changeButtonLabel(_btnCacheInterstitialAd, "Interstitial ad is cached!");
        changeButtonLabel(_btnShowInterstitialAd, "Show Interstitial Ad (Cached)");

        _btnShowInterstitialAd->setEnabled(true);
    }
}

void AdDemoView::handleAdCachingFailed(PCAdConfig* adConfig, std::map<std::string, std::string> extraValues)
{
    if (adConfig->screenName != _adConfig->screenName)
        return;
    
    // extract values
    std::string message = extraValues[FAIL_MESSAGE];
    
    CCLOG("%s %s ad caching failed for %s! message: %s", (adConfig->isRewarded ? "rewarded" : "non-rewarded"),
                                                         (adConfig->adFormat == VIDEO ? "video" : "interstitial"),
                                                         adConfig->screenName.c_str(),
                                                         message.c_str());
    
    changeLabelText(_txtStatus, "ad caching failed!");
    
    if (adConfig->adFormat == VIDEO)
    {
        changeButtonLabel(_btnCacheVideoAd, "Cache Video Ad");
        changeButtonLabel(_btnShowVideoAd, "Show Video Ad");
        _btnCacheVideoAd->setEnabled(true);
        _btnShowVideoAd->setEnabled(true);
    }
    else if (adConfig->adFormat == INTERSTITIAL)
    {
        changeButtonLabel(_btnCacheInterstitialAd, "Cache Interstitial Ad");
        changeButtonLabel(_btnShowInterstitialAd, "Show Interstitial Ad");
        _btnCacheInterstitialAd->setEnabled(true);
        _btnShowInterstitialAd->setEnabled(true);
    }
}

void AdDemoView::handleAdDisplayed(PCAdConfig* adConfig, std::map<std::string, std::string> extraValues)
{
    if (adConfig->screenName != _adConfig->screenName)
        return;
    
    // ignore extraValue param
    
    CCLOG("%s ad is displayed for %s!", (adConfig->isRewarded ? "rewarded" : "non-rewarded"), adConfig->screenName.c_str());
    
    changeLabelText(_txtStatus, "ad displayed!");
    
    if (adConfig->adFormat == VIDEO)
    {
        _btnCacheVideoAd->setEnabled(false);
        _btnShowVideoAd->setEnabled(false);
    }
    else if (adConfig->adFormat == INTERSTITIAL)
    {
        _btnCacheInterstitialAd->setEnabled(false);
        _btnShowInterstitialAd->setEnabled(false);
    }
}

void AdDemoView::handleAdSkipped(PCAdConfig* adConfig, std::map<std::string, std::string> extraValues)
{
    if (adConfig->screenName != _adConfig->screenName)
        return;
    
    // ignore extraValue param
    
    CCLOG("%s ad is skipped for %s!", (adConfig->isRewarded ? "rewarded" : "non-rewarded"), adConfig->screenName.c_str());
    
    changeLabelText(_txtStatus, "ad skipped!");
}

void AdDemoView::handleAdCompleted(PCAdConfig* adConfig, std::map<std::string, std::string> extraValues)
{
//    if (adConfig->screenName != _adConfig->screenName)
//        return;
    
    // ignore extraValue param
    
    CCLOG("%s ad is completed for %s!", (adConfig->isRewarded ? "rewarded" : "non-rewarded"), adConfig->screenName.c_str());
    
    changeLabelText(_txtStatus, "ad completed!");
}

void AdDemoView::handleAdClosed(PCAdConfig* adConfig, std::map<std::string, std::string> extraValues)
{
    if (adConfig->screenName != _adConfig->screenName)
        return;
    
    // extract values
    bool backPressed = extraValues[BACK_PRESSED].compare("true") == 0;
    
    CCLOG("%s ad is closed for %s!", (adConfig->isRewarded ? "rewarded" : "non-rewarded"), adConfig->screenName.c_str());
    
    if (adConfig->adFormat == VIDEO)
    {
        _btnCacheVideoAd->setEnabled(true);
        _btnShowVideoAd->setEnabled(true);
        changeButtonLabel(_btnCacheVideoAd, "Cache Video Ad");
        changeButtonLabel(_btnShowVideoAd, "Show Video Ad");
    }
    else if (adConfig->adFormat == INTERSTITIAL)
    {
        _btnCacheInterstitialAd->setEnabled(true);
        _btnShowInterstitialAd->setEnabled(true);
        changeButtonLabel(_btnCacheInterstitialAd, "Cache Interstitial Ad");
        changeButtonLabel(_btnShowInterstitialAd, "Show Interstitial Ad");
    }
}

void AdDemoView::handleAdGratified(PCAdConfig* adConfig, std::map<std::string, std::string> extraValues)
{
    if (adConfig->screenName != _adConfig->screenName)
        return;
    
    // extract values
    float reward = 0;
    std::stringstream(extraValues[REWARD]) >> reward;
    
    CCLOG("ad for %s is gratified! reward received: %f!", (adConfig->isRewarded ? "rewarded" : "non-rewarded"), reward);
    
    _coinsEarned += reward;
    
    char buf[100];
    sprintf(buf, "Points Earned: %f", _coinsEarned);
    changeLabelText(_txtPointsEarned, buf);
}
