#ifndef __CocosPokktApp__VideoView__
#define __CocosPokktApp__VideoView__

#include <stdio.h>
#include "BaseView.h"
#include "cocos2d.h"
#include "../../../../pokktsdk/pokkt.h"

using namespace cocos2d;
using namespace pokkt;

class AdDemoView : public BaseView
{
public:
    
    CREATE_FUNC(AdDemoView);
    
    virtual ~AdDemoView();
    
    virtual void handleBackPress(CCObject *);
    
    void setAdConfig(PCAdConfig* adConfig);
    
    static AdDemoView* getView(bool isRewarded);
    
protected:
    
    virtual bool init();
    
private:
    
    
    CCMenuItem* _btnCacheVideoAd;
    CCMenuItem* _btnShowVideoAd;
    CCMenuItem* _btnCacheInterstitialAd;
    CCMenuItem* _btnShowInterstitialAd;
    
    CCMenuItem* _btnExportLog;
    
    CCLabelTTF* _txtScreenName;
    CCLabelTTF* _txtPointsEarned;
    CCLabelTTF* _txtStatus;
        
    float _coinsEarned;
    PCAdConfig* _adConfig;
    
    // handlers
    void handleCacheVideoAd(CCObject* pSender);
    void handleShowVideoAd(CCObject* pSender);
    void handleCacheInterstitialAd(CCObject* pSender);
    void handleShowInterstitialAd(CCObject* pSender);
    void handleExportLog(CCObject* pSender);
    
    // pokkt handlers
    void handleAdAvailability(PCAdConfig* adConfig, std::map<std::string, std::string> extraValues);
    void handleAdCachingCompleted(PCAdConfig* adConfig, std::map<std::string, std::string> extraValues);
    void handleAdCachingFailed(PCAdConfig* adConfig, std::map<std::string, std::string> extraValues);
    void handleAdDisplayed(PCAdConfig* adConfig, std::map<std::string, std::string> extraValues);
    void handleAdSkipped(PCAdConfig* adConfig, std::map<std::string, std::string> extraValues);
    void handleAdCompleted(PCAdConfig* adConfig, std::map<std::string, std::string> extraValues);
    void handleAdClosed(PCAdConfig* adConfig, std::map<std::string, std::string> extraValues);
    void handleAdGratified(PCAdConfig* adConfig, std::map<std::string, std::string> extraValues);
};

#endif /* defined(__CocosPokktApp__VideoView__) */
