#ifndef __CocosPokktApp__BaseView__
#define __CocosPokktApp__BaseView__

#include <stdio.h>
#include <map>
#include "cocos2d.h"
#include "../../../../pokktsdk/pokkt.h"


class ChangeViewParams;

class BaseView : public cocos2d::CCLayer
{
public:
    
    enum AppView
    {
        OfferwallView,
        AdDemoView,
        DemoSelectorView
    };
    
    //AppView nextView;
    
    CREATE_FUNC(BaseView);
    
    virtual ~BaseView();
    
    virtual void update(float dt);
    virtual void handleBackPress(CCObject*);
    virtual void handleEnterForeground();
    virtual void keyBackClicked();
    
    static cocos2d::CCMenuItem* createButton(const char *label,
                                             cocos2d::SEL_MenuHandler selector,
                                             cocos2d::CCObject* target,
                                             const char *pszNormalFileName = "btn_blue_normal.png",
                                             const char *pszDownFileName = "btn_blue_down.png");
    
    static cocos2d::CCLabelTTF* createLabel(const char *label, int fontSize = 20,
                                            const cocos2d::ccColor3B &color = cocos2d::ccWHITE,
                                            const cocos2d::CCPoint &position = cocos2d::CCPoint(0, 0));
    
protected:
    
    cocos2d::CCSprite* logo;
    cocos2d::CCMenuItem* backButton;
    cocos2d::CCMenu* menuContainer;
    cocos2d::CCSize visibleSize;
    
    virtual bool init();
    void changeView(ChangeViewParams* params);
    void changeLabelText(cocos2d::CCLabelTTF* label, const char* text);
    void changeButtonLabel(cocos2d::CCMenuItem* button, const char* text);
    
private:
    
    std::map<cocos2d::CCLabelTTF*, const char*> _labelsToUpdate;
};

class ChangeViewParams : public cocos2d::CCObject
{
public:
    BaseView::AppView viewToChange;
    pokkt::PCAdConfig* adConfig;
};

#endif /* defined(__CocosPokktApp__BaseView__) */
