#include "DemoSelectorView.h"


/**
 * HELPER: getAdConfigForScreen
 *
 * this is just for this Demo-purpose, you should have
 * your own adConfig properly mainatined
 **/
static PCAdConfig* getAdConfigForRewardType(bool isRewarded, string screenName)
{
    PCAdConfig* adConfig = new PCAdConfig();
    
    if (isRewarded)
    {
        adConfig->isRewarded = true;
        adConfig->screenName = screenName;
        adConfig->defaultSkipTime = 5;
        adConfig->shouldAllowSkip = true;
        adConfig->shouldAllowMute = true;
        adConfig->shouldConfirmSkip = true;
        adConfig->skipConfirmMessage = "Do you want to skip the video?";
        adConfig->skipConfirmYesLabel = "Okay";
        adConfig->skipConfirmNoLabel = "Nope";
        adConfig->skipTimerMessage = "Must watch for ## seconds";
        adConfig->incentiveMessage = "more seconds to go!";
    }
    else
    {
        adConfig->isRewarded = false;
        adConfig->screenName = screenName;
        
        // keeping the rest as default
    }
    
    return adConfig;
}

static PCPokktConfig* config = new PCPokktConfig();
static DemoSelectorView* viewInstance = NULL;

bool DemoSelectorView::init()
{
    if (!BaseView::init())
        return false;
    
    backButton->setVisible(false);
    
    int yPos = logo->getPosition().y - logo->getContentSize().height / 2;
    
    
    //setTouchEnabled(true);
    setKeypadEnabled(true);
    
    CCSize editboxSize = CCSizeMake(600, 70);
    //681x108 is the dimension of my cell image
    
    //creating the image of textbox
	_txtFldScreenName = CCEditBox::create(editboxSize, CCScale9Sprite::create("whiteButton.png"), CCScale9Sprite::create("whiteButton.png"));
    _txtFldScreenName->setPosition(ccp(visibleSize.width / 2, yPos));
    _txtFldScreenName->setFontSize(14);
    _txtFldScreenName->setFontColor(ccBLACK);
    _txtFldScreenName->setMaxLength(15);
    
    _txtFldScreenName->setPlaceHolder("start");
    
    //there are many functions of keyboard types. You can choose according to your need
    _txtFldScreenName->setReturnType(kKeyboardReturnTypeDone);
    _txtFldScreenName->setInputMode(kEditBoxInputModeSingleLine);
    _txtFldScreenName->setDelegate(this);
    this->addChild(_txtFldScreenName);

    yPos -= 90;
    

	// create mandatory field label
	_txtScreenNameValidityMessage = createLabel("Screen Name cannot be empty!!", 30, ccBLACK, CCPoint(visibleSize.width / 2, yPos));
	_txtScreenNameValidityMessage->setVisible(false);
	this->addChild(_txtScreenNameValidityMessage);
    // create buttons
	yPos -= 90;

	_btnInitPokkt = createButton("Init Pokkt First", menu_selector(DemoSelectorView::handleInitPokkt), this, "btn_purple_normal.png", "btn_purple_down.png");
    _btnInitPokkt->setPosition(CCPoint(visibleSize.width / 2, yPos));
    _btnInitPokkt->setScale(0.7f);
    menuContainer->addChild(_btnInitPokkt);
    
    yPos -= 120;
    
    _btnStartDemo1 = createButton("Test Rewarded Ad", menu_selector(DemoSelectorView::handleStartDemo1), this);
    _btnStartDemo1->setPosition(CCPoint(visibleSize.width / 2, yPos));
    menuContainer->addChild(_btnStartDemo1);
    
    yPos -= 100;
    
    _btnStartDemo2 = createButton("Test NonRewarded Ad", menu_selector(DemoSelectorView::handleStartDemo2), this);
    _btnStartDemo2->setPosition(CCPoint(visibleSize.width / 2, yPos));
    menuContainer->addChild(_btnStartDemo2);
    
    yPos -= 100;
    
    _btnStartDemo3 = createButton("Test Banner Ad", menu_selector(DemoSelectorView::handleStartDemo3), this);
    _btnStartDemo3->setPosition(CCPoint(visibleSize.width / 2, yPos));
    menuContainer->addChild(_btnStartDemo3);

    
    yPos -= 100;
    
    _btnStartOfferwall = createButton("Start Offerwall", menu_selector(DemoSelectorView::handleStartOfferwall), this, "btn_purple_normal.png", "btn_purple_down.png");
    _btnStartOfferwall->setPosition(CCPoint(visibleSize.width / 2, yPos));
    menuContainer->addChild(_btnStartOfferwall);
    
    yPos -= 120;
    
    _btnExportLog = createButton("Export Log", menu_selector(DemoSelectorView::handleExportLog), this, "btn_purple_normal.png", "btn_purple_down.png");
    _btnExportLog->setPosition(CCPoint(visibleSize.width / 2, yPos));
    _btnExportLog->setScale(0.7f);
    menuContainer->addChild(_btnExportLog);
    
    // hide all buttons
    _btnStartDemo1->setVisible(false);
    _btnStartDemo2->setVisible(false);
    _btnStartDemo3->setVisible(false);
    _btnStartOfferwall->setVisible(false);
    
    // listen
    PCPokktManager::setPokktInitializedListener(PC_POKKT_INITIALIZED_EVENT_SELECTOR(DemoSelectorView::handlePokktInitialized), this);
    
    PCPokktManager::setBannerEventListener(BANNER_LOADED, PC_BANNER_EVENT_SELECTOR(DemoSelectorView::handleOnBannerLoaded), this);
    PCPokktManager::setBannerEventListener(BANNER_LOAD_FAILED, PC_BANNER_EVENT_SELECTOR(DemoSelectorView::handleOnBannerLoadFailed), this);

    // misc. pokkt flag setup
    PCPokktManager::setDebug(true);
    PCPokktManager::showLog("pokkt init...");
    
    return true;
}

DemoSelectorView::~DemoSelectorView()
{
    PCPokktManager::removePokktInitializedListener();
    PCPokktManager::removeBannerEventListener(BANNER_LOADED);
    PCPokktManager::removeBannerEventListener(BANNER_LOAD_FAILED);
}

PCPokktConfig* DemoSelectorView::getPokktConfig()
{
    // SET THESE UP AS PER VALUES PROVIDED TO YOU
    
    // SampleApp(videodemo) credentials
	config->securityKey = "81f2f0b8e67752ddd552f9b9e2c678f3";//"ae501f1003b0dc927dea807498ceaf3c"; //"91f118562047d230f2b907ba93d2c4e2";//"iJ02lJss0M";//"ae501f1003b0dc927dea807498ceaf3c"; //
	config->applicationId = "0f666bc5d176ce734443a4fe00183d63";//"954b975f9c753bcb8fca42624d78139a";//"4317fb1fcbf1ca98badf08ef59b0b86b";//"a2717a45b835b5e9f50284a38d62a74e";//"954b975f9c753bcb8fca42624d78139a";//
    config->integrationType = POKKT_INTEGRATION_TYPE_ALL;
    config->thirdPartyUserId = "123456";
    return config;
}

DemoSelectorView* DemoSelectorView::getView()
{
    if (viewInstance == NULL)
    {
        viewInstance = DemoSelectorView::create();
        viewInstance->retain();
    }
    return viewInstance;
}

void DemoSelectorView::handleBackPress(CCObject* obj)
{
    // exit the app
    CCDirector::sharedDirector()->end();
}

void DemoSelectorView::handleInitPokkt(cocos2d::CCObject* pSender)
{
    PCPokktManager::initPokkt(getPokktConfig());
    changeButtonLabel(_btnInitPokkt, "initializing...");
    _btnInitPokkt->setEnabled(false);
}

void DemoSelectorView::handleStartDemo1(cocos2d::CCObject* pSender)
{
	std::string text = _txtFldScreenName->getText();
	if (!text.empty() && text.length() != 0)
	{
        //    PCPokktManager::cacheAd(_adConfig);
		_txtScreenNameValidityMessage->setVisible(false);
        ChangeViewParams* params = new ChangeViewParams();
        params->viewToChange = AdDemoView;
		params->adConfig = getAdConfigForRewardType(true, _txtFldScreenName->getText());
        changeView(params);
    }
    else
    {
		_txtScreenNameValidityMessage->setVisible(true);
        CCLOG("Enter screen Name in the text box and then retry");
    }
}

void DemoSelectorView::handleStartDemo2(cocos2d::CCObject* pSender)
{
	std::string text = _txtFldScreenName->getText();
	if (!text.empty() && text.length() != 0)
    {
		_txtScreenNameValidityMessage->setVisible(false);
        ChangeViewParams* params = new ChangeViewParams();
        params->viewToChange = AdDemoView;
        params->adConfig = getAdConfigForRewardType(false, _txtFldScreenName->getText());
        changeView(params);
    }
    else
    {
		_txtScreenNameValidityMessage->setVisible(true);
        CCLOG("Enter screen Name in the text box and then retry");
    }

}

void DemoSelectorView::handleStartDemo3(cocos2d::CCObject* pSender)
{
	std::string text = _txtFldScreenName->getText();
	if (!text.empty() && text.length() != 0)
	{
		_txtScreenNameValidityMessage->setVisible(false);
		PCPokktManager::loadBanner(_txtFldScreenName->getText(), MIDDLE_CENTER);
    }
    else
    {
		_txtScreenNameValidityMessage->setVisible(true);
        CCLOG("Enter screen Name in the text box and then retry");
    }
}

void DemoSelectorView::handleStartOfferwall(cocos2d::CCObject* pSender)
{
    ChangeViewParams* params = new ChangeViewParams();
    params->viewToChange = OfferwallView;
    params->adConfig = NULL;
    changeView(params);
}

void DemoSelectorView::handleExportLog(cocos2d::CCObject* pSender)
{
    PCPokktManager::exportLog();
}

void DemoSelectorView::handlePokktInitialized(bool isReady, std::string message)
{
    CCLOG("PokktSDK intialisation callback message %s", message.c_str());
    _btnInitPokkt->setEnabled(!isReady);
    _btnStartDemo1->setVisible(isReady);
    _btnStartDemo2->setVisible(isReady);
    _btnStartDemo3->setVisible(isReady);
    _btnStartOfferwall->setVisible(isReady);
    
    if (isReady)
        changeButtonLabel(_btnInitPokkt, "pokkt initialised!");
}

void DemoSelectorView::handleOnBannerLoaded(std::string screenName, std::string extraValues)
{
    CCLOG("Banner Loaded For screen name %s", screenName.c_str());
}

void DemoSelectorView::handleOnBannerLoadFailed(std::string screenName, std::string errorMessage)
{
    CCLOG("Banner Loaded failed For screen name %s with error %s", screenName.c_str(), errorMessage.c_str());
}


void DemoSelectorView::editBoxEditingDidBegin(CCEditBox *editBox)
{
    // editBox-> attachWithIME();
	CCLOG("editBoxEditingDidBegin");
}

void DemoSelectorView::editBoxEditingDidEnd(CCEditBox *editBox)
{
//	editBox->detachWithIME();
	CCLOG("editBoxEditingDidEnd");
}

void DemoSelectorView::editBoxTextChanged(CCEditBox *editBox, string &text)
{
	CCLOG("editBoxTextChanged");
}

void DemoSelectorView::editBoxReturn(CCEditBox *editBox)
{
	CCLOG("editBoxReturn");
}
