#ifndef __CocosPokktApp__DemoSelectorView__
#define __CocosPokktApp__DemoSelectorView__

#include <stdio.h>
#include <map>
#include "BaseView.h"
#include "../../../../pokktsdk/pokkt.h"
#include "cocos-ext.h"

using namespace cocos2d;
using namespace pokkt;
using namespace std;
using namespace cocos2d::extension;


class DemoSelectorView : public BaseView, public CCEditBoxDelegate
{
public:
    
    CREATE_FUNC(DemoSelectorView);
    
    virtual void handleBackPress(CCObject*);
    
    static pokkt::PCPokktConfig* getPokktConfig();
    
    static DemoSelectorView* getView();
    
    ~DemoSelectorView();
    
protected:
    
    virtual bool init();
    
private:
    
	CCLabelTTF* _txtScreenNameValidityMessage;

    CCMenuItem* _btnInitPokkt;
    CCMenuItem* _btnStartDemo1;
    CCMenuItem* _btnStartDemo2;
    CCMenuItem* _btnStartDemo3;
    CCMenuItem* _btnStartOfferwall;
    CCMenuItem* _btnExportLog;
    
    CCEditBox* _txtFldScreenName;

    // listeners
    void handleInitPokkt(CCObject* pSender);
    void handleStartDemo1(CCObject* pSender);
    void handleStartDemo2(CCObject* pSender);
    void handleStartDemo3(CCObject* pSender);
    void handleStartOfferwall(CCObject* pSender);
    void handleExportLog(CCObject* pSender);
    
    void handlePokktInitialized(bool isReady, std::string messsage);
    void handleOnBannerLoaded(std::string screenName, std::string extraValues);
    void handleOnBannerLoadFailed(std::string screenName, std::string errorMessage);
    
    virtual void editBoxEditingDidBegin(CCEditBox* editBox);
    virtual void editBoxEditingDidEnd(CCEditBox* editBox);
    virtual void editBoxTextChanged(CCEditBox* editBox, string &text);
    virtual void editBoxReturn(CCEditBox * editBox);
};

#endif /* defined(__CocosPokktApp__DemoSelectorView__) */
