#ifndef __CocosPokktApp__OfferwallView__
#define __CocosPokktApp__OfferwallView__

#include <stdio.h>
#include "BaseView.h"
#include "cocos2d.h"
#include "../../../../pokktsdk/pokkt.h"

using namespace cocos2d;
using namespace pokkt;


class OfferwallView : public BaseView
{
public:
    
    CREATE_FUNC(OfferwallView);
    
    virtual ~OfferwallView();
    
    static OfferwallView* getView();
    
	virtual void handleBackPress(CCObject*);
    virtual void handleEnterForeground();
    
protected:
    
    virtual bool init();
    
private:
    
    CCMenuItem* _btnGetOfferwallAny;
    CCMenuItem* _btnGetOfferwallFix;
    CCMenuItem* _btnIncompleteCallback;
    CCMenuItem* _btnExportLog;
    
    CCLabelTTF* _txtPointsEarned;
    CCTextFieldTTF* _txiEnterMaxPoints;
    
    int _coinsEarned;
    
    // handlers
    void handleGetOfferwallAny(cocos2d::CCObject *pSender);
    void handleGetOfferwallFix(cocos2d::CCObject *pSender);
    void handleIncompleteCallback(cocos2d::CCObject *pSender);
    void handleExportLog(cocos2d::CCObject *pSender);
    
    // pokkt handlers
    void handleCoinResponse(std::string coins);
    void handleCoinResponseWithTrId(std::string coinsWithTrId);
    void handleCoinResponseFailed(std::string message);
    void handleCampaignAvailibity(std::string message);
    void handleOfferwallclosed(std::string message);
};

#endif /* defined(__CocosPokktApp__OfferwallView__) */
