#ifndef PCAdConfig_h
#define PCAdConfig_h

#include <stdio.h>


namespace pokkt
{
    class PCAdConfig
    {
    public:
        std::string screenName;
        bool isRewarded;
        
        bool backButtonDisabled;
        int defaultSkipTime;
        int adFormat;
        bool shouldAllowSkip;
        bool shouldAllowMute;
        bool shouldConfirmSkip;
        std::string skipConfirmMessage;
        std::string skipConfirmYesLabel;
        std::string skipConfirmNoLabel;
        std::string skipTimerMessage;
        std::string incentiveMessage;
        
        bool operator==(const PCAdConfig& adConfig)
        {
            return (screenName == adConfig.screenName && isRewarded == adConfig.isRewarded && adFormat == adConfig.adFormat);
        }
        
        PCAdConfig()
        {
            // default values
            backButtonDisabled = false;
            screenName = "Default";
            defaultSkipTime = 10;
            adFormat = 0;
            shouldAllowSkip = true;
            shouldAllowMute = true;
            shouldConfirmSkip = true;
            skipConfirmMessage = "Skipping this video will earn you NO rewards. Are you sure?";
            skipConfirmYesLabel = "Yes";
            skipConfirmNoLabel = "No";
            skipTimerMessage = "You can skip this video in ## seconds"; // the '##' will be replaced by digits
            incentiveMessage = "more seconds only for your reward!";
        }
    };
}

#endif /* PCAdConfig_h */
