#include "DemoSelectorView.h"


/**
 * HELPER: getAdConfigForScreen
 *
 * this is just for this Demo-purpose, you should have
 * your own adConfig properly mainatined
 **/
static PCAdConfig* getAdConfigForScreen(bool isRewarded, std::string screenName)
{
    PCAdConfig* adConfig = new PCAdConfig();
    
    if (isRewarded)
    {
        adConfig->screenName = screenName;
        adConfig->isRewarded = true;
        
        adConfig->defaultSkipTime = 5;
        adConfig->shouldAllowSkip = true;
        adConfig->shouldAllowMute = true;
        adConfig->shouldConfirmSkip = true;
        adConfig->skipConfirmMessage = "Do you want to skip the video?";
        adConfig->skipConfirmYesLabel = "Okay";
        adConfig->skipConfirmNoLabel = "Nope";
        adConfig->skipTimerMessage = "Must watch for ## seconds";
        adConfig->incentiveMessage = "more seconds to go!";
    }
    else
    {
        adConfig->screenName = "DemoScreen2";
        
        // keeping the rest as default
    }
    
    return adConfig;
}

static PCPokktConfig* config = new PCPokktConfig();
static DemoSelectorView* viewInstance = NULL;

bool DemoSelectorView::init()
{
    if (!BaseView::init())
        return false;
    
    backButton->setVisible(false);
    
    int yPos = logo->getPosition().y - logo->getBoundingBox().size.height / 2;
    
    // create buttons
    
    _screenNameEditBox = EditBox::create(Size(3 * visibleSize.width / 4, 70), "whiteButton.png");
    _screenNameEditBox->setPlaceHolder("start");
    _screenNameEditBox->setFontColor(Color3B::BLACK);
    _screenNameEditBox->setPosition((Vec2(visibleSize.width / 2, yPos)));
    //_screenNameEditBox->setFontSize(35);
    _screenNameEditBox->setInputMode(EditBox::InputMode::ANY);
    _screenNameEditBox->setDelegate(this);
    _screenNameEditBox->setReturnType(EditBox::KeyboardReturnType::DONE);
    addChild(_screenNameEditBox);
    
    yPos -= 80;

	// create mandatory field label
	_txtScreenNameValidityMessage = createLabel("Screen Name cannot be empty!!", 30, ccBLACK, CCPoint(visibleSize.width / 2, yPos));
	_txtScreenNameValidityMessage->setVisible(false);
	this->addChild(_txtScreenNameValidityMessage);
    
	yPos -= 80;

    _btnInitPokkt = createButton("Init Pokkt First", CC_CALLBACK_1(DemoSelectorView::handleInitPokkt, this), "button_purple.png");
    _btnInitPokkt->setPosition(Vec2(visibleSize.width / 2, yPos));
    _btnInitPokkt->setScale(0.7f);
    this->addChild(_btnInitPokkt);
    
    yPos -= 120;
    
    _btnStartDemo1 = createButton("Test Rewarded Ad", CC_CALLBACK_1(DemoSelectorView::handleStartDemo1, this));
    _btnStartDemo1->setPosition(Vec2(visibleSize.width / 2, yPos));
    this->addChild(_btnStartDemo1);
    
    yPos -= 100;
    
    _btnStartDemo2 = createButton("Test NonRewarded Ad", CC_CALLBACK_1(DemoSelectorView::handleStartDemo2, this));
    _btnStartDemo2->setPosition(Vec2(visibleSize.width / 2, yPos));
    this->addChild(_btnStartDemo2);
    
    yPos -= 100;
    
    _btnStartDemo3 = createButton("Test Banner Ad", CC_CALLBACK_1(DemoSelectorView::handleStartDemo3, this));
    _btnStartDemo3->setPosition(Vec2(visibleSize.width / 2, yPos));
    this->addChild(_btnStartDemo3);
    
    yPos -= 100;
    
    _btnStartOfferwall = createButton("Start Offerwall", CC_CALLBACK_1(DemoSelectorView::handleStartOfferwall, this), "button_purple.png");
    _btnStartOfferwall->setPosition(Vec2(visibleSize.width / 2, yPos));
    this->addChild(_btnStartOfferwall);
    
    yPos -= 120;
    
    _btnExportLog = createButton("Export Log", CC_CALLBACK_1(DemoSelectorView::handleExportLog, this), "button_purple.png");
    _btnExportLog->setPosition(Vec2(visibleSize.width / 2, yPos));
    _btnExportLog->setScale(0.7f);
    this->addChild(_btnExportLog);
    
    // hide all buttons
    _btnStartDemo1->setVisible(false);
    _btnStartDemo2->setVisible(false);
    _btnStartDemo3->setVisible(false);
    _btnStartOfferwall->setVisible(false);
    
    // listen
    PCPokktManager::setPokktInitializedListener(PC_POKKT_INITIALIZED_EVENT_SELECTOR(DemoSelectorView::handlePokktInitialized), this);
    
    PCPokktManager::setBannerEventListener(BANNER_LOADED, PC_BANNER_EVENT_SELECTOR(DemoSelectorView::handleOnBannerLoaded), this);
    PCPokktManager::setBannerEventListener(BANNER_LOAD_FAILED, PC_BANNER_EVENT_SELECTOR(DemoSelectorView::handleOnBannerLoadFailed), this);
    
    // misc. pokkt flag setup
    PCPokktManager::setDebug(true);
    PCPokktManager::showLog("pokkt init...");
    
    return true;
}

DemoSelectorView::~DemoSelectorView()
{
    PCPokktManager::removePokktInitializedListener();
}

PCPokktConfig* DemoSelectorView::getPokktConfig()
{
    // SET THESE UP AS PER VALUES PROVIDED TO YOU
    
    // SampleApp(videodemo) credentials
	config->securityKey = "iJ02lJss0M";
    config->applicationId = "a2717a45b835b5e9f50284a38d62a74e";
    config->integrationType = POKKT_INTEGRATION_TYPE_ALL;
    config->thirdPartyUserId = "123456";
    
    return config;
}

DemoSelectorView* DemoSelectorView::getView()
{
    if (viewInstance == NULL)
    {
        viewInstance = DemoSelectorView::create();
        viewInstance->retain();
    }
    return viewInstance;
}

void DemoSelectorView::handleBackPress(cocos2d::Ref *pSender)
{
    // exit the app
    Director::getInstance()->end();
}

void DemoSelectorView::handleInitPokkt(cocos2d::Ref* pSender)
{
    _btnInitPokkt->setTitleText("initializing...");
    _btnInitPokkt->setEnabled(false);
    PCPokktManager::initPokkt(getPokktConfig());
}

void DemoSelectorView::handleStartDemo1(cocos2d::Ref* pSender)
{
	std::string text = _screenNameEditBox->getText();
	if (!text.empty() && text.length() != 0)
	{
		_txtScreenNameValidityMessage->setVisible(false);
		ChangeViewParams params;
		params.viewToChange = AdDemoView;
		params.adConfig = getAdConfigForScreen(true, _screenNameEditBox->getText());
		changeView(params);
	}
	else
	{
		_txtScreenNameValidityMessage->setVisible(true);
		CCLOG("Enter screen Name in the text box and then retry");
	}
}

void DemoSelectorView::handleStartDemo2(cocos2d::Ref* pSender)
{
	std::string text = _screenNameEditBox->getText();
	if (!text.empty() && text.length() != 0)
	{
		_txtScreenNameValidityMessage->setVisible(false);
		ChangeViewParams params;
		params.viewToChange = AdDemoView;
		params.adConfig = getAdConfigForScreen(false, _screenNameEditBox->getText());
		changeView(params);
	}
	else
	{
		_txtScreenNameValidityMessage->setVisible(true);
		CCLOG("Enter screen Name in the text box and then retry");
	}
}

void DemoSelectorView::handleStartDemo3(cocos2d::Ref* pSender)
{
	std::string text = _screenNameEditBox->getText();
	if (!text.empty() && text.length() != 0)
    {
		_txtScreenNameValidityMessage->setVisible(false);
        PCPokktManager::loadBanner(_screenNameEditBox->getText(), BOTTOM_CENTER);
    }
    else
    {
		_txtScreenNameValidityMessage->setVisible(true);
        CCLOG("Enter screen Name in the text box and then retry");
    }
}

void DemoSelectorView::handleStartOfferwall(cocos2d::Ref* pSender)
{
    ChangeViewParams params;
    params.viewToChange = OfferwallView;
    changeView(params);
}

void DemoSelectorView::handleExportLog(cocos2d::Ref* pSender)
{
    PCPokktManager::exportLog();
}

void DemoSelectorView::handlePokktInitialized(bool isReady, std::string message)
{
    CCLOG("Pokkt Initialised message %s", message.c_str());
    
    _btnInitPokkt->setEnabled(!isReady);
    _btnStartDemo1->setVisible(isReady);
    _btnStartDemo2->setVisible(isReady);
    _btnStartDemo3->setVisible(isReady);
    _btnStartOfferwall->setVisible(isReady);
    
    if (isReady)
        _btnInitPokkt->setTitleText("pokkt initialised!");
}

void DemoSelectorView::handleOnBannerLoaded(std::string screenName, std::string extraValues)
{
    CCLOG("Banner Loaded For screen name %s", screenName.c_str());
}

void DemoSelectorView::handleOnBannerLoadFailed(std::string screenName, std::string errorMessage)
{
    CCLOG("Banner Loaded failed For screen name %s with error %s", screenName.c_str(), errorMessage.c_str());
}

void DemoSelectorView::editBoxEditingDidBegin(EditBox* editBox)
{
    _screenNameEditBox->attachWithIME();
}

void DemoSelectorView::editBoxEditingDidEnd(EditBox* editBox)
{
    
}

void DemoSelectorView::editBoxTextChanged(EditBox* editBox, const std::string& text)
{
    
}

void DemoSelectorView::editBoxReturn(EditBox* editBox)
{
    
}
