#ifndef __CocosPokktApp__DemoSelectorView__
#define __CocosPokktApp__DemoSelectorView__

#include <stdio.h>
#include "BaseView.h"
#include "../../../../pokktsdk/pokkt.h"
#include "ui/UIEditBox/UIEditBox.h"

using namespace cocos2d;
using namespace ui;
using namespace pokkt;


class DemoSelectorView : public BaseView, public ui::EditBoxDelegate
{
public:
    
    CREATE_FUNC(DemoSelectorView);
    
    virtual void handleBackPress(cocos2d::Ref* pSender);
    
    static pokkt::PCPokktConfig* getPokktConfig();
    
    static DemoSelectorView* getView();
    
    ~DemoSelectorView();
    
protected:
    
    virtual bool init();
    
private:

	Text* _txtScreenNameValidityMessage;
    
    Button* _btnInitPokkt;
    Button* _btnStartDemo1;
    Button* _btnStartDemo2;
    Button* _btnStartDemo3;
    Button* _btnStartOfferwall;
    Button* _btnExportLog;
    
    EditBox* _screenNameEditBox;
    //ui::EditBox* editBox;
    // listeners
    void handleInitPokkt(Ref* pSender);
    void handleStartDemo1(Ref* pSender);
    void handleStartDemo2(Ref* pSender);
    void handleStartDemo3(Ref* pSender);
    void handleStartOfferwall(Ref* pSender);
    void handleExportLog(Ref* pSender);
    
    void handlePokktInitialized(bool isReady, std::string message);
    void handleOnBannerLoaded(std::string screenName, std::string extraValues);
    void handleOnBannerLoadFailed(std::string screenName, std::string errorMessage);
    
    void editBoxEditingDidBegin(EditBox* editBox);
    void editBoxEditingDidEnd(EditBox* editBox);
    void editBoxTextChanged(EditBox* editBox, const std::string& text);
    void editBoxReturn(EditBox* editBox);

    
    
};

#endif /* defined(__CocosPokktApp__DemoSelectorView__) */
